diff -Nru WRFV3.5/dyn_em/module_initialize_les.F WRFV3.5_MR/dyn_em/module_initialize_les.F
--- WRFV3.5/dyn_em/module_initialize_les.F	2009-06-19 23:17:46.000000000 +0200
+++ WRFV3.5_MR/dyn_em/module_initialize_les.F	2014-12-17 11:53:56.080235000 +0100
@@ -23,6 +23,7 @@
    USE module_timing
    USE module_configure
    USE module_init_utilities
+   USE module_soil_pre
 #ifdef DM_PARALLEL
    USE module_dm
 #endif
@@ -39,6 +40,9 @@
 ! copies of assumed-shape arrays (by passing down as arguments, the 
 ! data are treated as assumed-size -- ie. f77 -- arrays and the copying
 ! business is avoided).  Fie on the F90 designers.  Fie and a pox.
+! NOTE:  Modified to remove all but arrays of rank 4 or more from the 
+!        argument list.  Arrays with rank>3 are still problematic due to the 
+!        above-noted fie- and pox-ities.  TBH 20061129.  
 
    SUBROUTINE init_domain ( grid )
 
@@ -56,7 +60,6 @@
 #include <actual_new_args.inc>
 !
                         )
-
    END SUBROUTINE init_domain
 
 !-------------------------------------------------------------------
@@ -80,21 +83,17 @@
                                   ids, ide, jds, jde, kds, kde, &
                                   ims, ime, jms, jme, kms, kme, &
                                   its, ite, jts, jte, kts, kte, &
-                                  i, j, k
-
-   ! Local data
+                                  i, j, k, ll
 
    INTEGER, PARAMETER :: nl_max = 1000
    REAL, DIMENSION(nl_max) :: zk, p_in, theta, rho, u, v, qv, pd_in
    INTEGER :: nl_in
 
-
-   INTEGER :: icm,jcm, ii, im1, jj, jm1, loop, error, fid, nxc, nyc
+   INTEGER :: icm,jcm, ii, im1, jj, jm1, loop, error, fid, nxc, nyc, lm
    REAL    :: u_mean,v_mean, f0, p_surf, p_level, qvf, z_at_v, z_at_u
    REAL    :: z_scale, xrad, yrad, zrad, rad, delt, cof1, cof2
 !   REAL, EXTERNAL :: interp_0
-   REAL    :: hm
-   REAL    :: pi
+   REAL    :: pi, rnd
 
 !  stuff from original initialization that has been dropped from the Registry 
    REAL    :: vnu, xnu, xnus, dinit0, cbh, p0_temp, t0_temp, zd, zt
@@ -104,13 +103,22 @@
 
    LOGICAL :: moisture_init
    LOGICAL :: stretch_grid, dry_sounding
+   character (len=256) :: mminlu2
 
-  INTEGER :: xs , xe , ys , ye
-  REAL :: mtn_ht
-   LOGICAL, EXTERNAL :: wrf_dm_on_monitor
+!  cjw begin
+!  variables for topography
+   REAL                            :: hp, Ly, Sy, Sx, X1, X2, X3, X4, shiftx, shifty 
+   REAL, DIMENSION(:), ALLOCATABLE :: hx, hy
+   REAL                            :: xx, yy 
+   INTEGER                         :: istart, iend, jstart, jend 
+   INTEGER, DIMENSION(:), ALLOCATABLE  :: valley_maskl, valley_maskr, &
+                                          valley_maskx, valley_masky
 !  For LES, add randx
    real :: randx
+!  cjw end
+   character*256 :: msg !cmr
 
+ 
 #ifdef DM_PARALLEL
 #    include <data_calls.inc>
 #endif
@@ -157,16 +165,14 @@
    END SELECT
 
 
-!  stretch_grid = .true.
-!  FOR LES, set stretch to false
    stretch_grid = .false.
-   delt = 3.
-!   z_scale = .50
+!   delt = 6.
    z_scale = .40
    pi = 2.*asin(1.0)
    write(6,*) ' pi is ',pi
    nxc = (ide-ids)/2
-   nyc = (jde-jds)/2
+   nyc = jde/2
+   icm = ide/2
 
    CALL model_to_grid_config_rec ( grid%id , model_config_rec , config_flags )
 
@@ -183,50 +189,86 @@
    CALL wrf_dm_bcast_bytes( jcm , IWORDSIZE )
 #endif
 
-    CALL nl_set_mminlu(1, '    ')
-    CALL nl_set_iswater(1,0)
-    CALL nl_set_cen_lat(1,40.)
-    CALL nl_set_cen_lon(1,-105.)
-    CALL nl_set_truelat1(1,0.)
-    CALL nl_set_truelat2(1,0.)
+    mminlu2 = ' '
+    mminlu2(1:4) = 'USGS'
+    CALL nl_set_mminlu(1, mminlu2)
+!   CALL nl_set_mminlu(1, 'USGS')
+    CALL nl_set_iswater(1,16)
+    CALL nl_set_isice(1,3)
+    CALL nl_set_cen_lat(1,model_config_rec%valley_latitude)
+    CALL nl_set_cen_lon(1,model_config_rec%valley_longitude)
+    CALL nl_set_truelat1(1,model_config_rec%valley_latitude)
+    CALL nl_set_truelat2(1,model_config_rec%valley_longitude)
     CALL nl_set_moad_cen_lat (1,0.)
     CALL nl_set_stand_lon (1,0.)
     CALL nl_set_pole_lon (1,0.)
     CALL nl_set_pole_lat (1,90.)
     CALL nl_set_map_proj(1,0)
+!   CALL model_to_grid_config_rec(1,model_config_rec,config_flags)
+    CALL nl_get_iswater(1,grid%iswater)
 
-
-!  here we initialize data we currently is not initialized 
+!  here we initialize data that currently is not initialized 
 !  in the input data
 
     DO j = jts, jte
       DO i = its, ite
+         grid%msft(i,j)     = 1.
+         grid%msfu(i,j)     = 1.
+         grid%msfv(i,j)     = 1.
          grid%msftx(i,j)    = 1.
          grid%msfty(i,j)    = 1.
          grid%msfux(i,j)    = 1.
          grid%msfuy(i,j)    = 1.
          grid%msfvx(i,j)    = 1.
-         grid%msfvx_inv(i,j)= 1.
          grid%msfvy(i,j)    = 1.
+         grid%msfvx_inv(i,j)= 1.
          grid%sina(i,j)     = 0.
          grid%cosa(i,j)     = 1.
          grid%e(i,j)        = 0.
-!  for LES, include Coriolis force
-         grid%f(i,j)        = 1.e-4 
-
+         grid%f(i,j)        = 0.
       END DO
    END DO
 
-    DO j = jts, jte
+! for Noah LSM, additional variables need to be initialized
+
+   other_masked_fields : SELECT CASE ( model_config_rec%sf_surface_physics(grid%id) )
+
+      CASE (SLABSCHEME)
+
+
+      CASE (LSMSCHEME)
+
+! cjw: LSM variables are initialised further down
+
+      CASE (RUCLSMSCHEME)
+
+   END SELECT other_masked_fields
+
+   DO j = jts, jte
     DO k = kts, kte
       DO i = its, ite
          grid%ww(i,k,j)     = 0.
       END DO
-   END DO
+    END DO
    END DO
 
    grid%step_number = 0
 
+! Process the soil; note that there are some things hard-wired into share/module_soil_pre.F
+! cjw begin: soil properties initialised further down
+
+!      CALL process_soil_ideal(grid%xland,grid%xice,grid%vegfra,grid%snow,grid%canwat, &
+!                     grid%ivgtyp,grid%isltyp,grid%tslb,grid%smois, &
+!                     grid%tsk,grid%tmn,grid%zs,grid%dzs,model_config_rec%num_soil_layers, &
+!                     model_config_rec%sf_surface_physics(grid%id), &
+!                                   ids,ide, jds,jde, kds,kde,&
+!                                   ims,ime, jms,jme, kms,kme,&
+!                                   its,ite, jts,jte, kts,kte )
+
+! cjw end
+
+
+
 ! set up the grid
 
    IF (stretch_grid) THEN ! exponential stretch for eta (nearly constant dz)
@@ -236,7 +278,10 @@
      ENDDO
    ELSE
      DO k=1, kde
-      grid%znw(k) = 1. - float(k-1)/float(kde-1)
+! cjw      grid%znw(k) = 1. - float(k-1)/float(kde-1)
+! cjw begin
+      grid%znw(k) = model_config_rec%eta_levels(k)
+! cjw end
      ENDDO
    ENDIF
 
@@ -266,21 +311,9 @@
 !  get the sounding from the ascii sounding file, first get dry sounding and 
 !  calculate base state
 
-  dry_sounding = .true.
-  IF ( wrf_dm_on_monitor() ) THEN
   write(6,*) ' getting dry sounding for base state '
-
+  dry_sounding = .true.
   CALL get_sounding( zk, p_in, pd_in, theta, rho, u, v, qv, dry_sounding, nl_max, nl_in )
-  ENDIF
-  CALL wrf_dm_bcast_real( zk , nl_max )
-  CALL wrf_dm_bcast_real( p_in , nl_max )
-  CALL wrf_dm_bcast_real( pd_in , nl_max )
-  CALL wrf_dm_bcast_real( theta , nl_max )
-  CALL wrf_dm_bcast_real( rho , nl_max )
-  CALL wrf_dm_bcast_real( u , nl_max )
-  CALL wrf_dm_bcast_real( v , nl_max )
-  CALL wrf_dm_bcast_real( qv , nl_max )
-  CALL wrf_dm_bcast_integer ( nl_in , 1 ) 
 
   write(6,*) ' returned from reading sounding, nl_in is ',nl_in
 
@@ -289,50 +322,202 @@
 
   grid%p_top = interp_0( p_in, zk, config_flags%ztop, nl_in )
 
-  DO j=jts,jte
+!  cjw begin
+!  compute topography
+   hp = model_config_rec%valley_topo_hp
+   Ly = model_config_rec%valley_topo_ly 
+   Sy = model_config_rec%valley_topo_sy
+   Sx = model_config_rec%valley_topo_sx
+   X1 = model_config_rec%valley_topo_x1
+   X2 = model_config_rec%valley_topo_x2
+   X3 = model_config_rec%valley_topo_x3
+   X4 = model_config_rec%valley_topo_x4
+   shiftx = model_config_rec%valley_topo_shiftx
+   shifty = model_config_rec%valley_topo_shifty
+   allocate(hx(its:ite))
+   allocate(hy(jts:jte))
+   allocate(valley_maskx(its:ite))
+   allocate(valley_masky(jts:jte))
+
+  xx = 0.
+  yy = 0.
+!  compute hy(j)
+!cmr tranpose topo hx<->hy
+! now compute hx(j)
   DO i=its,ite
-    grid%ht(i,j) = 0.
-  ENDDO
-  ENDDO
+    IF (yy-shifty <= -Sy) THEN 
+      hx(i) = 0.
+      valley_maskx(i) = 0
+    ELSEIF (yy-shifty >= 2.*Ly+Sy) THEN
+      hx(i) = 0.
+      valley_maskx(i) = 0
+    ELSEIF (yy-shifty > -Sy .and. yy-shifty < 0.) THEN
+      hx(i) = 0.5 + 0.5*cos((pi/Sy)*(yy-shifty))
+      valley_maskx(i) = 0
+    ELSEIF (yy-shifty > 2.*Ly .and. yy-shifty < 2.*Ly+Sy) THEN
+      hx(i) = 0.5 + 0.5*cos((pi/Sy)*(yy-shifty-2.*Ly))
+      valley_maskx(i) = 0
+    ELSEIF (yy-shifty >= 0. .and. yy-shifty <= 2.*Ly ) THEN
+      hx(i) = 1.
+      valley_maskx(i) = 1
+    ENDIF
+    yy = yy + config_flags%dy
+  ENDDO 
 
-  xs=ide/2 -3
-  xs=ids   -3
-  xe=xs + 6
-  ys=jde/2 -3
-  ye=ys + 6
-  mtn_ht = 500
-#ifdef MTN
-  DO j=max(ys,jds),min(ye,jde-1)
-  DO i=max(xs,ids),min(xe,ide-1)
-     grid%ht(i,j) = mtn_ht * 0.25 * &
-               ( 1. + COS ( 2*pi/(xe-xs) * ( i-xs ) + pi ) ) * &
-               ( 1. + COS ( 2*pi/(ye-ys) * ( j-ys ) + pi ) )
-  ENDDO
-  ENDDO
-#endif
-#ifdef EW_RIDGE
-  DO j=max(ys,jds),min(ye,jde-1)
-  DO i=ids,ide
-     grid%ht(i,j) = mtn_ht * 0.50 * &
-               ( 1. + COS ( 2*pi/(ye-ys) * ( j-ys ) + pi ) )
+!  compute(hx(i))
+! changed to hy(j)
+  DO j=jts,jte
+    IF (xx-shiftx >= -X1 .and. xx-shiftx <= X1) THEN
+      hy(j) = 0.
+      valley_masky(j) = 1
+    ELSEIF (xx-shiftx > X1 .and. xx-shiftx < X2) THEN
+      hy(j) = 0.5 - 0.5*cos((pi/Sx)*((xx-shiftx)-X1))
+      valley_masky(j) = 1
+    ELSEIF (xx-shiftx > -X2 .and. xx-shiftx < -X1) THEN
+      hy(j) = 0.5 - 0.5*cos((pi/Sx)*((-xx+shiftx)-X1))
+      valley_masky(j) = 1
+    ELSEIF (xx-shiftx >= X2 .and. xx-shiftx <= X3) THEN
+      hy(j) = 1.
+      valley_masky(j) = 1
+    ELSEIF (xx-shiftx >= -X3 .and. xx-shiftx <= -X2) THEN
+      hy(j) = 1.
+      valley_masky(j) = 1
+    ELSEIF (xx-shiftx > X3 .and. xx-shiftx < X4) THEN
+      hy(j) = 0.5 + 0.5*cos((pi/Sx)*((xx-shiftx)-X3))
+      valley_masky(j) = 0
+    ELSEIF (xx-shiftx > -X4 .and. xx-shiftx < -X3) THEN
+      hy(j) = 0.5 + 0.5*cos((pi/Sx)*((-xx+shiftx)-X3))
+      valley_masky(j) = 0
+    ELSEIF (xx-shiftx >= X4 .or. xx-shiftx <= -X4) THEN
+      hy(j) = 0.
+      valley_masky(j) = 0
+    ENDIF
+    xx = xx + config_flags%dx
+  ENDDO 
+
+! ==== Get centre of valley:
+  i = its
+  DO WHILE (valley_maskx(i) /= 1)
+     i = i + 1 
   ENDDO
+  istart = i
+
+  i = ite
+  DO WHILE (valley_maskx(i) /= 1)
+     i = i - 1 
   ENDDO
-#endif
-#ifdef NS_RIDGE
-  DO j=jds,jde
-  DO i=max(xs,ids),min(xe,ide-1)
-     grid%ht(i,j) = mtn_ht * 0.50 * &
-               ( 1. + COS ( 2*pi/(xe-xs) * ( i-xs ) + pi ) )
+  iend = i
+
+  j = jts
+  DO WHILE (valley_masky(j) /= 1)
+     j = j + 1 
   ENDDO
+  jstart = j
+
+  j = jte
+  DO WHILE (valley_masky(j) /= 1)
+     j = j - 1 
   ENDDO
-#endif
+  jend = j
+
   DO j=jts,jte
-  DO i=its,ite
-    grid%phb(i,1,j) = g * grid%ht(i,j)
-    grid%ph0(i,1,j) = g * grid%ht(i,j)
+  DO i=its,ite  
+!cmr 20.02.14 transposed topo   
+    IF (config_flags%valley_CO2flat .eq. 1) THEN
+      grid%ht(i,j) = hp/2.
+    ELSE
+      grid%ht(i,j) = hp*hy(j)*hx(i)
+    ENDIF
+    grid%valley_mask(i,j) = valley_maskx(i)*valley_masky(j)
+    grid%phb(i,1,j) = g*grid%ht(i,j)
+    grid%php(i,1,j) = 0.
+    grid%ph0(i,1,j) = grid%phb(i,1,j)
   ENDDO
   ENDDO
 
+!cmr flat topo switch: 
+! cmr end
+ 
+  deallocate(hx)
+  deallocate(hy)
+  deallocate(valley_maskx)
+  deallocate(valley_masky)
+
+!  ! ==== Compute valley_mask: 1=valley; 0=no valley:
+!  allocate(valley_maskl(its:ite))
+!  allocate(valley_maskr(its:ite))
+!
+!
+!  DO j=jts,jte
+!
+!     valley_maskl(its) = 0
+!     DO i=its+1,ite  
+!        IF (grid%ht(i,j) == hp .and. valley_maskl(i-1) == 0) THEN
+!           valley_maskl(i) = 1
+!        ELSEIF (grid%ht(i,j) < hp .and. valley_maskl(i-1) == 0) THEN
+!           valley_maskl(i) = 0
+!        ELSEIF (valley_maskl(i-1) == 1) THEN
+!           valley_maskl(i) = 1
+!        ENDIF
+!     ENDDO
+!
+!     valley_maskr(ite) = 0
+!     DO i=ite-1,its,-1
+!        IF (valley_maskr(i+1) == 0 .and. grid%ht(i,j) == hp) THEN
+!           valley_maskr(i) = 1
+!        ELSEIF (valley_maskr(i+1) == 1) THEN
+!           valley_maskr(i) = 1
+!        ELSEIF (valley_maskr(i+1) == 0 .and. grid%ht(i,j) < hp) THEN
+!           valley_maskr(i) = 0
+!        ENDIF
+!     ENDDO
+!
+!     DO i = its,ite
+!        grid%valley_mask(i,j) = valley_maskl(i) * valley_maskr(i)
+!     ENDDO
+!
+!  ENDDO
+!
+!  deallocate(valley_maskl)
+!  deallocate(valley_maskr)
+
+  ! ==== Compute mask for entry, exit of valle in y- and x-direction:
+  grid%valley_xinout_mask  = 0
+  grid%valley_xin_mask     = 0
+  grid%valley_xout_mask    = 0
+  grid%valley_yinout_mask  = 0
+  grid%valley_yin_mask     = 0
+  grid%valley_yout_mask    = 0
+
+  j=jts
+  DO WHILE (maxval(grid%valley_mask(:,j)) == 0)
+     j = j + 1
+  ENDDO
+  grid%valley_yinout_mask(:,j) = grid%valley_mask(:,j) 
+  grid%valley_yin_mask(:,j) = grid%valley_mask(:,j) 
+
+  j=jte-2
+  DO WHILE (maxval(grid%valley_mask(:,j)) == 0)
+     j = j - 1
+  ENDDO 
+  grid%valley_yinout_mask(:,j) = grid%valley_mask(:,j) 
+  grid%valley_yout_mask(:,j) = grid%valley_mask(:,j) 
+
+  i=its          
+  DO WHILE (maxval(grid%valley_mask(i,:)) == 0)
+     i = i + 1
+  ENDDO
+  grid%valley_xinout_mask(i,:) = grid%valley_mask(i,:)
+  grid%valley_xin_mask(i,:) = grid%valley_mask(i,:)
+
+  i=ite-2          
+  DO WHILE (maxval(grid%valley_mask(i,:)) == 0)
+     i = i - 1
+  ENDDO
+  grid%valley_xinout_mask(i,:) = grid%valley_mask(i,:)
+  grid%valley_xout_mask(i,:) = grid%valley_mask(i,:)
+!  cjw end
+
   DO J = jts, jte
   DO I = its, ite
 
@@ -360,10 +545,19 @@
   ENDDO
   ENDDO
 
-  IF ( wrf_dm_on_monitor() ) THEN
-    write(6,*) ' ptop is ',grid%p_top
-    write(6,*) ' base state grid%mub(1,1), p_surf is ',grid%mub(1,1),grid%mub(1,1)+grid%p_top
-  ENDIF
+! cjw begin
+  DO j = jts, jte
+     DO i = its, ite
+        DO k = kts,kte-1
+        grid%ZPVALCENTRE(i,k,j) = (0.5*(grid%phb(int(0.5*(iend+istart)),k,int(0.5*(jend+jstart))) + &
+                               grid%phb(int(0.5*(iend+istart)),k+1,int(0.5*(jend+jstart)))))/9.81 
+        ENDDO  
+     ENDDO
+  ENDDO
+! cjw end
+
+  write(6,*) ' ptop is ',grid%p_top
+  write(6,*) ' base state grid%mub(1,1), p_surf is ',grid%mub(1,1),grid%mub(1,1)+grid%p_top
 
 !  calculate full state for each column - this includes moisture.
 
@@ -444,52 +638,51 @@
       grid%ph0(i,k,j) = grid%ph_1(i,k,j) + grid%phb(i,k,j)
     ENDDO
 
-    IF ( wrf_dm_on_monitor() ) THEN
     if((i==2) .and. (j==2)) then
      write(6,*) ' grid%ph_1 calc ',grid%ph_1(2,1,2),grid%ph_1(2,2,2),&
                               grid%mu_1(2,2)+grid%mub(2,2),grid%mu_1(2,2), &
                               grid%alb(2,1,2),grid%al(1,2,1),grid%rdnw(1)
     endif
-    ENDIF
 
   ENDDO
   ENDDO
 
-!#if 0
+! cjw begin
 
-!  thermal perturbation to kick off convection
+   if (model_config_rec%valley_randx .eq. 1) then
+! add random perturbations to perturbation theta
 
+!   if (0.gt.1) then
+!
+!!#if 0
+!!  The seabreeze case is adapted from the squall line case
+!!  so we just turn off the thermal perturbation
+!
+!!  thermal perturbation to kick off convection
+ call random_seed
   write(6,*) ' nxc, nyc for perturbation ',nxc,nyc
-  write(6,*) ' delt for perturbation ',delt
-
-! For LES, change the initial random perturbations
-! For 2D test, call randx outside I-loop
-! For 3D runs, call randx inside both I-J loops
-
+!  write(6,*) ' delt for perturbation ',delt
+!
   DO J = jts, min(jde-1,jte)
-!   yrad = config_flags%dy*float(j-nyc)/10000.
-    yrad = 0.
+!!    yrad = config_flags%dy*float(j-nyc)/4000.
+     yrad = 0.
     DO I = its, min(ide-1,ite)
-!     xrad = config_flags%dx*float(i-nxc)/10000.
-      xrad = 0.
-      call random_number (randx)
-      randx = randx - 0.5
-!     DO K = 1, kte-1
-      DO K = 1, 4 
+!      xrad = config_flags%dx*float(i-nxc)/10000.
+     xrad = 0.
+     call random_number (randx)
+     randx = randx - 0.5
+      DO K = 1, 5
 
 !  No bubbles for LES!
 !  put in preturbation theta (bubble) and recalc density.  note,
 !  the mass in the column is not changing, so when theta changes,
 !  we recompute density and geopotential
 
-!       zrad = 0.5*(grid%ph_1(i,k,j)+grid%ph_1(i,k+1,j)  &
-!                  +grid%phb(i,k,j)+grid%phb(i,k+1,j))/g
-!       zrad = (zrad-1500.)/1500.
         zrad = 0.
         RAD=SQRT(xrad*xrad+yrad*yrad+zrad*zrad)
         IF(RAD <= 1.) THEN
 !          grid%t_1(i,k,j)=grid%t_1(i,k,j)+delt*COS(.5*PI*RAD)**2
-           grid%t_1(i,k,j)=grid%t_1(i,k,j)+ 0.1 *randx
+           grid%t_1(i,k,j)=grid%t_1(i,k,j)+ randx
            grid%t_2(i,k,j)=grid%t_1(i,k,j)
            qvf = 1. + rvovrd*moist(i,k,j,P_QV)
            grid%alt(i,k,j) = (r_d/p1000mb)*(grid%t_1(i,k,j)+t0)*qvf* &
@@ -497,24 +690,64 @@
            grid%al(i,k,j) = grid%alt(i,k,j) - grid%alb(i,k,j)
         ENDIF
       ENDDO
-
 !  rebalance hydrostatically
 
       DO k  = 2,kte
         grid%ph_1(i,k,j) = grid%ph_1(i,k-1,j) - (1./grid%rdnw(k-1))*(       &
                      (grid%mub(i,j)+grid%mu_1(i,j))*grid%al(i,k-1,j)+ &
                       grid%mu_1(i,j)*grid%alb(i,k-1,j)  )
-                                                   
-        grid%ph_2(i,k,j) = grid%ph_1(i,k,j) 
+
+        grid%ph_2(i,k,j) = grid%ph_1(i,k,j)
         grid%ph0(i,k,j) = grid%ph_1(i,k,j) + grid%phb(i,k,j)
       ENDDO
 
     ENDDO
   ENDDO
 
+
+
+!
+!!  put in preturbation theta (bubble) and recalc density.  note,
+!!  the mass in the column is not changing, so when theta changes,
+!!  we recompute density and geopotential
+!        zrad = 0.5*(grid%ph_1(i,k,j)+grid%ph_1(i,k+1,j)  &
+!                   +grid%phb(i,k,j)+grid%phb(i,k+1,j))/g
+!        zrad = (zrad-1500.)/1500.
+!        RAD=SQRT(xrad*xrad+yrad*yrad+zrad*zrad)
+!!        IF(RAD <= 1.) THEN
+!	call RANDOM_NUMBER(rnd)
+!	  grid%t_1(i,k,j)=grid%t_1(i,k,j)+delt*(rnd-0.5)
+!         !  grid%t_1(i,k,j)=grid%t_1(i,k,j)+delt*COS(.5*PI*RAD)**2
+!           grid%t_2(i,k,j)=grid%t_1(i,k,j)
+!           qvf = 1. + rvovrd*moist(i,k,j,P_QV)
+!           grid%alt(i,k,j) = (r_d/p1000mb)*(grid%t_1(i,k,j)+t0)*qvf* &
+!                        (((grid%p(i,k,j)+grid%pb(i,k,j))/p1000mb)**cvpm)
+!           grid%al(i,k,j) = grid%alt(i,k,j) - grid%alb(i,k,j)
+!!        ENDIF
+!      ENDDO
+!
+!!  rebalance hydrostatically
+!
+!      DO k  = 2,kte
+!        grid%ph_1(i,k,j) = grid%ph_1(i,k-1,j) - (1./grid%rdnw(k-1))*(       &
+!                     (grid%mub(i,j)+grid%mu_1(i,j))*grid%al(i,k-1,j)+ &
+!                      grid%mu_1(i,j)*grid%alb(i,k-1,j)  )
+!                                                   
+!        grid%ph_2(i,k,j) = grid%ph_1(i,k,j) 
+!        grid%ph0(i,k,j) = grid%ph_1(i,k,j) + grid%phb(i,k,j)
+!      ENDDO
+!
+!    ENDDO
+!  ENDDO
+
+!   endif 
+
+endif
+
+! cjw end
+
 !#endif
 
-   IF ( wrf_dm_on_monitor() ) THEN
    write(6,*) ' grid%mu_1 from comp ', grid%mu_1(1,1)
    write(6,*) ' full state sounding from comp, ph, grid%p, grid%al, grid%t_1, qv '
    do k=1,kde-1
@@ -529,7 +762,6 @@
                                       grid%p(1,k,1), grid%al(1,k,1), &
                                       grid%t_1(1,k,1), moist(1,k,1,P_QV)
    enddo
-   ENDIF
 
 ! interp v
 
@@ -543,9 +775,10 @@
     ELSE
       z_at_v = 0.5*(grid%phb(i,1,j)+grid%phb(i,1,j-1))/g
     END IF
+
     p_surf = interp_0( p_in, zk, z_at_v, nl_in )
 
-    DO K = 1, kte-1
+    DO K = 1, kte
       p_level = grid%znu(k)*(p_surf - grid%p_top) + grid%p_top
       grid%v_1(i,k,j) = interp_0( v, p_in, p_level, nl_in )
       grid%v_2(i,k,j) = grid%v_1(i,k,j)
@@ -569,7 +802,7 @@
 
     p_surf = interp_0( p_in, zk, z_at_u, nl_in )
 
-    DO K = 1, kte-1
+    DO K = 1, kte
       p_level = grid%znu(k)*(p_surf - grid%p_top) + grid%p_top
       grid%u_1(i,k,j) = interp_0( u, p_in, p_level, nl_in )
       grid%u_2(i,k,j) = grid%u_1(i,k,j)
@@ -599,7 +832,6 @@
   ENDDO
   ENDDO
 
-  IF ( wrf_dm_on_monitor() ) THEN
   DO k=1,kte-1
     grid%t_base(k) = grid%t_1(1,k,1)
     grid%qv_base(k) = moist(1,k,1,P_QV)
@@ -607,33 +839,220 @@
     grid%v_base(k) = grid%v_1(1,k,1)
     grid%z_base(k) = 0.5*(grid%phb(1,k,1)+grid%phb(1,k+1,1)+grid%ph_1(1,k,1)+grid%ph_1(1,k+1,1))/g
   ENDDO
-  ENDIF
-  CALL wrf_dm_bcast_real( grid%t_base , kte )
-  CALL wrf_dm_bcast_real( grid%qv_base , kte )
-  CALL wrf_dm_bcast_real( grid%u_base , kte )
-  CALL wrf_dm_bcast_real( grid%v_base , kte )
-  CALL wrf_dm_bcast_real( grid%z_base , kte )
+     
+! cjw begin
+SELECT CASE ( model_config_rec%sf_surface_physics(grid%id) )
+
+!cmrwrite:
+!   write(msg,*)'model_config_rec%sf_surface_physics(grid%id)=',model_config_rec%sf_surface_physics(grid%id)
+!   CALL wrf_debug(0,msg)
+
+
+CASE (LSMSCHEME)
+! define soil manually instead of calling process_soil_ideal:
+
+! get soil layers (share/module_soil_pre.F):
+
+   CALL init_soil_depth_2 (grid%zs , grid%dzs , model_config_rec%num_soil_layers)
+
+! define land properties:
+  DO j = jts , MIN(jde-1,jte)
+     DO i = its , MIN(ide-1,ite)
+
+        thtmp   = grid%t_2(i,1,j)+t0
+        ptmp    = grid%p(i,1,j)+grid%pb(i,1,j)
+        temp(1) = thtmp * (ptmp/p1000mb)**rcp
+        thtmp   = grid%t_2(i,2,j)+t0
+        ptmp    = grid%p(i,2,j)+grid%pb(i,2,j)
+        temp(2) = thtmp * (ptmp/p1000mb)**rcp
+        thtmp   = grid%t_2(i,3,j)+t0
+        ptmp    = grid%p(i,3,j)+grid%pb(i,3,j)
+        temp(3) = thtmp * (ptmp/p1000mb)**rcp
+
+        grid%tsk(i,j)=grid%cf1*temp(1)+grid%cf2*temp(2)+grid%cf3*temp(3)
+        grid%tmn(i,j)=grid%tsk(i,j)+model_config_rec%valley_tsk_tmn
+
+
+        DO ll = 1,model_config_rec%num_soil_layers
+           ! constant soil moisture:
+           grid%smois(i,ll,j) = model_config_rec%valley_smois
+           ! logarithmical soil temperature profile:
+           grid%tslb(i,ll,j) = grid%tsk(i,j) + (grid%tmn(i,j) - grid%tsk(i,j)) * &
+                               log(((exp(1.) - 1.)/grid%zs(model_config_rec%num_soil_layers)) * &
+                               grid%zs(ll) + 1.) 
+        ENDDO
+        grid%xland(i,j)    = 1.
+        grid%xice(i,j)     = 0.
+        grid%snow(i,j)     = 0.
+        grid%xlat(i,j)     = model_config_rec%valley_latitude
+        grid%xlong(i,j)    = model_config_rec%valley_longitude
+        grid%lai(i,j)      = model_config_rec%valley_lai
+        grid%vegfra(i,j)   = model_config_rec%valley_vegfra 
+        grid%lu_index(i,j)  = model_config_rec%valley_lu_index
+        grid%canwat(i,j) = model_config_rec%valley_canwat
+        grid%isltyp(i,j) = model_config_rec%valley_isltyp
+        grid%ivgtyp(i,j) = model_config_rec%valley_ivgtyp
+     ENDDO
+  ENDDO
 
-  DO J = jts, min(jde-1,jte)
-  DO I = its, min(ide-1,ite)
-     thtmp   = grid%t_2(i,1,j)+t0
-     ptmp    = grid%p(i,1,j)+grid%pb(i,1,j)
-     temp(1) = thtmp * (ptmp/p1000mb)**rcp
-     thtmp   = grid%t_2(i,2,j)+t0
-     ptmp    = grid%p(i,2,j)+grid%pb(i,2,j)
-     temp(2) = thtmp * (ptmp/p1000mb)**rcp
-     thtmp   = grid%t_2(i,3,j)+t0
-     ptmp    = grid%p(i,3,j)+grid%pb(i,3,j)
-     temp(3) = thtmp * (ptmp/p1000mb)**rcp
-
-!    For LES-CBL, add 5 degrees to the surface temperature!
-!
-!    grid%tsk(I,J)=grid%cf1*temp(1)+grid%cf2*temp(2)+grid%cf3*temp(3)
-     grid%tsk(I,J)=grid%cf1*temp(1)+grid%cf2*temp(2)+grid%cf3*temp(3)+5.
-     grid%tmn(I,J)=grid%tsk(I,J)-0.5
+
+
+
+CASE (SLABSCHEME)
+
+! get soil layers (share/module_soil_pre.F):
+  CALL init_soil_depth_1 (grid%zs , grid%dzs , model_config_rec%num_soil_layers)
+
+! define land properties:
+  DO j = jts , MIN(jde-1,jte)
+     DO i = its , MIN(ide-1,ite)
+
+        thtmp   = grid%t_2(i,1,j)+t0
+        ptmp    = grid%p(i,1,j)+grid%pb(i,1,j)
+        temp(1) = thtmp * (ptmp/p1000mb)**rcp
+        thtmp   = grid%t_2(i,2,j)+t0
+        ptmp    = grid%p(i,2,j)+grid%pb(i,2,j)
+        temp(2) = thtmp * (ptmp/p1000mb)**rcp
+        thtmp   = grid%t_2(i,3,j)+t0
+        ptmp    = grid%p(i,3,j)+grid%pb(i,3,j)
+        temp(3) = thtmp * (ptmp/p1000mb)**rcp
+
+        grid%tsk(i,j)=grid%cf1*temp(1)+grid%cf2*temp(2)+grid%cf3*temp(3)
+        grid%tmn(i,j)=grid%tsk(i,j)+model_config_rec%valley_tsk_tmn
+
+        DO ll = 1,model_config_rec%num_soil_layers
+           ! logarithmical soil temperature profile:
+!           grid%tslb(i,ll,j) = grid%tsk(i,j) + (grid%tmn(i,j) - grid%tsk(i,j)) * &
+!                               log(((exp(1.) -1.)/grid%zs(model_config_rec%num_soil_layers)) * &
+!                               grid%zs(ll) + 1.)
+
+           ! tslb from init_soil_1_ideal (share/module_soil_pre.F)
+           grid%tslb(i,ll,j) = ( grid%tsk(i,j)*(grid%zs(model_config_rec%num_soil_layers)- & 
+                                 grid%zs(ll)) + grid%tmn(i,j)*(grid%zs(ll)-grid%zs(1)) ) / &
+                               ( grid%zs(model_config_rec%num_soil_layers)-grid%zs(1) )
+
+
+        ENDDO
+        grid%xland(i,j)    = 1.
+        grid%xice(i,j)     = 0.
+        grid%snow(i,j)     = 0.
+        grid%xlat(i,j)     = model_config_rec%valley_latitude
+        grid%xlong(i,j)    = model_config_rec%valley_longitude
+        grid%lai(i,j)      = model_config_rec%valley_lai
+        grid%vegfra(i,j)   = model_config_rec%valley_vegfra
+        grid%lu_index(i,j)  = model_config_rec%valley_lu_index
+        grid%canwat(i,j) = model_config_rec%valley_canwat
+        grid%isltyp(i,j) = model_config_rec%valley_isltyp
+        grid%ivgtyp(i,j) = model_config_rec%valley_ivgtyp
+     ENDDO
   ENDDO
+
+!cmr begin : add CLM SCHEME
+CASE (CLMSCHEME)
+! define soil manually instead of calling process_soil_ideal:
+
+! get soil layers (share/module_soil_pre.F):
+
+   CALL init_soil_depth_4 (grid%zs , grid%dzs ,model_config_rec%num_soil_layers)
+!cmrwrite:
+!   write(msg,*)'max zs=',maxval(grid%zs),'max dzs=',maxval(grid%dzs),'num_soil_layers=',model_config_rec%num_soil_layers
+!   CALL wrf_debug(0,msg)
+
+! define land properties:
+  DO j = jts , MIN(jde-1,jte)
+     DO i = its , MIN(ide-1,ite)
+
+        thtmp   = grid%t_2(i,1,j)+t0
+        ptmp    = grid%p(i,1,j)+grid%pb(i,1,j)
+        temp(1) = thtmp * (ptmp/p1000mb)**rcp
+        thtmp   = grid%t_2(i,2,j)+t0
+        ptmp    = grid%p(i,2,j)+grid%pb(i,2,j)
+        temp(2) = thtmp * (ptmp/p1000mb)**rcp
+        thtmp   = grid%t_2(i,3,j)+t0
+        ptmp    = grid%p(i,3,j)+grid%pb(i,3,j)
+        temp(3) = thtmp * (ptmp/p1000mb)**rcp
+
+        grid%tsk(i,j)=grid%cf1*temp(1)+grid%cf2*temp(2)+grid%cf3*temp(3)
+        grid%tmn(i,j)=grid%tsk(i,j)+model_config_rec%valley_tsk_tmn
+
+        DO ll = 1,model_config_rec%num_soil_layers
+           ! constant soil moisture:
+           grid%smois(i,ll,j) = model_config_rec%valley_smois
+           ! logarithmical soil temperature profile:
+           grid%tslb(i,ll,j) = grid%tsk(i,j) + (grid%tmn(i,j) - grid%tsk(i,j)) * &
+                               log(((exp(1.) - 1.)/grid%zs(model_config_rec%num_soil_layers)) * &
+                               grid%zs(ll) + 1.) 
+!add more clm variables? -> if Initialized values are overwritten in clm again
+!           grid%t_grnd(i,ll,j)     = grid%tslb(i,1,j)
+!           grid%t_veg(i,ll,j)     = grid%tslb(i,1,j)
+!           grid%h2ocan(i,ll,j)     = model_config_rec%valley_smois
+!           grid%h2ocan_col(i,ll,j) = 1
+!           grid%h2osno(i,ll,j)      = 0.
+! also albedo?           grid%albedosubgrid(i,m,j) =
+
+        ENDDO
+        grid%xland(i,j)    = 1.
+        grid%xice(i,j)     = 0.
+        grid%snow(i,j)     = 0.
+        grid%xlat(i,j)     = model_config_rec%valley_latitude
+        grid%xlong(i,j)    = model_config_rec%valley_longitude
+        grid%lai(i,j)      = model_config_rec%valley_lai
+        grid%vegfra(i,j)   = model_config_rec%valley_vegfra 
+        grid%lu_index(i,j)  = model_config_rec%valley_lu_index
+        grid%canwat(i,j) = model_config_rec%valley_canwat
+        grid%isltyp(i,j) = model_config_rec%valley_isltyp
+        grid%ivgtyp(i,j) = model_config_rec%valley_ivgtyp
+     ENDDO
+   ENDDO
+!cmrwrite:
+   write(msg,*) 'grid%tslb(20,1:3,20)',grid%tslb(20,1,20),grid%tsk(20,20),grid%tmn(20,20)
+   CALL wrf_debug(0,msg)
+   write(msg,*) 'grid%tslb(1,1:3,1)',grid%tslb(1,1,1),grid%tslb(1,2,1),grid%tslb(1,3,1)
+   CALL wrf_debug(0,msg)
+   write(msg,*) 'maxval(grid%h20can)',maxval(grid%h2ocan(:,1,:)),maxval(grid%h2ocan(:,2,:))
+   CALL wrf_debug(0,msg)
+!   write(msg,*) 'grid%tmn',maxval(grid%tmn)
+!   CALL wrf_debug(0,msg)
+!cmr end
+
+CASE DEFAULT
+
+! define land properties:
+  DO j = jts , MIN(jde-1,jte)
+     DO i = its , MIN(ide-1,ite)
+
+        thtmp   = grid%t_2(i,1,j)+t0
+        ptmp    = grid%p(i,1,j)+grid%pb(i,1,j)
+        temp(1) = thtmp * (ptmp/p1000mb)**rcp
+        thtmp   = grid%t_2(i,2,j)+t0
+        ptmp    = grid%p(i,2,j)+grid%pb(i,2,j)
+        temp(2) = thtmp * (ptmp/p1000mb)**rcp
+        thtmp   = grid%t_2(i,3,j)+t0
+        ptmp    = grid%p(i,3,j)+grid%pb(i,3,j)
+        temp(3) = thtmp * (ptmp/p1000mb)**rcp
+
+        grid%tsk(i,j)=grid%cf1*temp(1)+grid%cf2*temp(2)+grid%cf3*temp(3)
+        grid%tmn(i,j)=grid%tsk(i,j)+model_config_rec%valley_tsk_tmn
+
+        grid%xland(i,j)    = 1.
+        grid%xice(i,j)     = 0.
+        grid%snow(i,j)     = 0.
+        grid%xlat(i,j)     = model_config_rec%valley_latitude
+        grid%xlong(i,j)    = model_config_rec%valley_longitude
+        grid%lai(i,j)      = model_config_rec%valley_lai
+        grid%vegfra(i,j)   = model_config_rec%valley_vegfra
+        grid%lu_index(i,j)  = model_config_rec%valley_lu_index
+        grid%canwat(i,j) = model_config_rec%valley_canwat
+        grid%isltyp(i,j) = model_config_rec%valley_isltyp
+        grid%ivgtyp(i,j) = model_config_rec%valley_ivgtyp
+     ENDDO
   ENDDO
 
+END SELECT
+! cjw end
+
+  RETURN
+
  END SUBROUTINE init_domain_rk
 
    SUBROUTINE init_module_initialize
@@ -673,7 +1092,7 @@
       logical dry
 
       integer n
-      parameter(n=1000)
+      parameter(n=3000)
       logical debug
       parameter( debug = .true.)
 
@@ -775,7 +1194,7 @@
 
 
         do k=1,nl
-
+! For the seabreeze case, we can hard-wire the winds and qv fields 
           zk(k) = h_input(k)
           p(k) = pm_input(k)
           p_dry(k) = p_input(k)
diff -Nru WRFV3.5/job_compile_wrf WRFV3.5_MR/job_compile_wrf
--- WRFV3.5/job_compile_wrf	1970-01-01 01:00:00.000000000 +0100
+++ WRFV3.5_MR/job_compile_wrf	2014-12-17 11:53:56.254450000 +0100
@@ -0,0 +1,13 @@
+#!/bin/bash
+#$ -o output.dat
+#$ -e error.dat
+#$ -cwd
+#$ -l h_vmem=8G,h_rt=02:00:00
+#$ -j yes
+#$ -R y
+#$ -N wrf_compile
+
+WRF_CASE='em_les'
+
+./compile $WRF_CASE >& compile.log
+
